Program ObjektideYlesanne;

{
Objektide ksitlemise lesanne
Programmeerimine II
6. lesanne
Erki Suurjaak
970772
LAP41
19.02.1999
}

uses crt, dos;

Const
 Norm = $1e1f;
 Null = $2000;

procedure MuudaKursor (Kursor : Word);
var R : Registers;

begin
  R.ah := $01;
  R.ch := Hi(Kursor);
  R.cl := Lo(Kursor);
  Intr($10, R);
end;


type TKoht = object
     private
           X : byte;
           Y : byte;
     public
           constructor Vaartusta (KusX, KusY : byte);
           procedure PaneUudeKohta (UusX, UusY : byte);
     end;


     TTaht = object (TKoht)
     private
           Symbol : char;
     public
           constructor Vaartusta (KusX, KusY : byte; MisSymbol : char);
           procedure PaneUudeKohta (UusX, UusY : byte);
           procedure Naita; virtual;
           procedure Kustuta; virtual;
     end;


     TSona = object (TKoht)
     private
           Vaartus : string;
     public
           constructor Vaartusta (KusX, KusY : byte; MisVaartus : string);
           procedure PaneUudeKohta (UusX, UusY : byte);
           procedure MuudaVaartust (UusVaartus : string);
           procedure Naita; virtual;
           procedure Kustuta; virtual;
     end;


     TVarvSona = object (TSona)
     private
           Varv : byte;
     public
           constructor Vaartusta (KusX, KusY : byte; MisVaartus : string; MisVarv : byte);
           procedure Naita; virtual;
           procedure Kustuta; virtual;
     end;

     TLiikuvVarvSona = object (TVarvSona)
     private
           MuutX : byte;
           MuutY : byte;
           Refresh : word;
     public
           constructor Vaartusta (KusX, KusY : byte; MisVaartus : string;
                                 MisVarv : byte; MisMuutX, MisMuutY : shortint;
                                 MisRefresh : word);
           procedure Liiguta;
     end;

(*-----------------------------------------------*)

constructor TKoht.Vaartusta;
begin
     X := KusX;
     Y := KusY;
end;

procedure TKoht.PaneUudeKohta;
begin
     X := UusX;
     Y := UusY;
end;

(*-----------------------------------------------*)

constructor TTaht.Vaartusta;
begin
     inherited Vaartusta (KusX, KusY);
     Symbol := MisSymbol;
end;

procedure TTaht.PaneUudeKohta;
begin
     Kustuta;
     inherited PaneUudeKohta (UusX, UusY);
     Naita;
end;

procedure TTaht.Naita;
begin
     GotoXY (X, Y);
     write (Symbol);
end;

procedure TTaht.Kustuta;
begin
     GotoXY (X, Y);
     write (' ');
end;

(*-----------------------------------------------*)

constructor TSona.Vaartusta;
begin
     inherited Vaartusta (KusX, KusY);
     Vaartus := MisVaartus;
end;

procedure TSona.PaneUudeKohta;
begin
     Kustuta;
     inherited PaneUudeKohta (UusX, UusY);
     Naita;
end;

procedure TSona.MuudaVaartust;
begin
     Vaartus := UusVaartus;
end;

procedure TSona.Naita;
begin
     GotoXY (X, Y);
     write (Vaartus);
end;

procedure TSona.Kustuta;
begin
     TextAttr := 7;
     GotoXY (X, Y);
     write (' ':length(Vaartus));
end;

(*-----------------------------------------------*)

constructor TVarvSona.Vaartusta;
begin
     inherited Vaartusta (KusX, KusY, MisVaartus);
     Varv := MisVarv;
end;

procedure TVarvSona.Naita;
var HetkVarv : byte;
begin
     HetkVarv := TextAttr;
     TextAttr := Varv;
     inherited Naita;
     TextAttr := HetkVarv;
end;

procedure TVarvSona.Kustuta;
begin
     inherited Kustuta;
end;

(*-----------------------------------------------*)

constructor TLiikuvVarvSona.Vaartusta;
begin
     inherited Vaartusta (KusX, KusY, MisVaartus, MisVarv);
     MuutX := MisMuutX;
     MuutY := MisMuutY;
     Refresh := MisRefresh;
end;


procedure TLiikuvVarvSona.Liiguta;
var tempx, tempy : byte;
begin
     repeat
     tempx := X + MuutX;
     tempy := Y + MuutY;
     If (tempx < 1) or (tempx + length(Vaartus) > 81) then
      begin
      MuutX := - MuutX;
      tempx := X + MuutX;
      end;
     If (tempy < 1) or (tempy > 25) then
      begin
      MuutY := - MuutY;
      tempy := Y + MuutY;
      end;
      inherited Kustuta;
      X := tempx;
      Y := tempy;
      inherited Naita;
     delay (Refresh);
     until KeyPressed;
     readkey;
     inherited Kustuta;
end;

(*-----------------------------------------------*)

var Taht : TTaht;
    Sona : TSona;
    VarvSona : TVarvSona;
    LiikuvVarvSona : TLiikuvVarvSona;


BEGIN
     TextAttr := 7;
     ClrScr;
     MuudaKursor (Null);
     Taht.Vaartusta (40, 13, '*');
     Sona.Vaartusta (30, 4, 'See on sna. See seal keskel on tht.');
     VarvSona.Vaartusta (60, 20, 'Vrviline sna.', 30);
     Taht.Naita;
     Sona.Naita;
     VarvSona.Naita;
     Readkey;
     Taht.PaneUudeKohta (2, 2);
     Sona.PaneUudeKohta (40, 1);
     VarvSona.PaneUudeKohta (40, 25);
     Readkey;
     Taht.Kustuta;
     Sona.Kustuta;
     VarvSona.Kustuta;

     LiikuvVarvSona.Vaartusta (33, 14, 'Liikuv vrviline sna.', 74, 4, 1, 38);
     LiikuvVarvSona.Liiguta;
     LiikuvVarvSona.MuudaVaartust ('Liigub nagu miska.');
     LiikuvVarvSona.Liiguta;
     LiikuvVarvSona.Kustuta;
     MuudaKursor (Norm);



END.
